## corsix-th 0.60

=== CMakeLists.txt ===
# Cmake File for CorsixTH
# OPTIONS AVAILABLE:
# At most, one of the following:
#   - WITH_SDL     : Activate SDL Renderer (default)
# Any of the following:
#   - WITH_AUDIO   : Activate Sound (enabled by default)
#   - WITH_FREETYPE2
#   - WITH_MOVIES  : Activate movies (requires Sound)
#   - BUILD_ANIMVIEWER
#   - WITH_LUAJIT  : Whether to use LuaJIT 2 instead of Lua51 (default is LuaJIT 2)
#   - WITH_LIBAV   : Whether to use LibAV (as opposed to FFMEPG) when building movies
#   - WITH_VLD     : Build with Visual Leak Detector (requires Visual Studio)

PROJECT(CorsixTH_Top_Level)
CMAKE_MINIMUM_REQUIRED(VERSION 2.6)
SET(CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/CMake)
INCLUDE(CheckCXXCompilerFlag)
CHECK_CXX_COMPILER_FLAG("-std=c++11" COMPILER_SUPPORTS_CXX11)
CHECK_CXX_COMPILER_FLAG("-std=c++0x" COMPILER_SUPPORTS_CXX0X)
IF(COMPILER_SUPPORTS_CXX11)
  SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11")
ELSEIF(COMPILER_SUPPORTS_CXX0X)
  SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++0x")
ENDIF(COMPILER_SUPPORTS_CXX11)
IF (MINGW)
  set(CMAKE_EXE_LINKER_FLAGS "-static-libgcc -static-libstdc++")
ENDIF(MINGW)
INCLUDE(CheckIncludeFiles)
SET(CORSIX_TH_DONE_TOP_LEVEL_CMAKE ON)

# Define our options
OPTION(WITH_SDL "Activate SDL Renderer" ON) # our default option
OPTION(WITH_AUDIO "Activate Sound" ON) # enabled by default
OPTION(WITH_MOVIES "Activate in game movies" ON)
OPTION(WITH_FREETYPE2 "Enhanced Font Support" ON)
OPTION(WITH_LUAJIT "Use LuaJIT instead of Lua" OFF)
OPTION(WITH_LIBAV "Use LibAV instead of FFmpeg" OFF)
OPTION(BUILD_ANIMVIEWER "Build the animation viewer as part of the build process" OFF)
IF(MSVC)
  OPTION(WITH_VLD "Build with Visual Leak Detector for Visual Studio" OFF)
ENDIF(MSVC)

IF(WITH_AUDIO)
  SET(CORSIX_TH_USE_SDL_MIXER ON)
  MESSAGE("Note: SDL audio is enabled (default)")
ELSE()
  SET(CORSIX_TH_USE_SDL_MIXER OFF)
  MESSAGE("Note: SDL audio is disabled")
ENDIF(WITH_AUDIO)

IF(WITH_MOVIES)
  IF(WITH_AUDIO)
    IF(WITH_LIBAV)
      SET(CORSIX_TH_USE_FFMPEG OFF)
      SET(CORSIX_TH_USE_LIBAV ON)
      MESSAGE("Note: LibAV video is enabled")
    ELSE()
      SET(CORSIX_TH_USE_FFMPEG ON)
      SET(CORSIX_TH_USE_LIBAV OFF)
      MESSAGE("Note: FFMPEG video is enabled (default)")
    ENDIF(WITH_LIBAV)
  ELSE()
    SET(CORSIX_TH_USE_FFMPEG OFF)
    SET(CORSIX_TH_USE_LIBAV OFF)
    MESSAGE("Note: FFMPEG video disabled since it requires SDL audio.")
  ENDIF(WITH_AUDIO)
ELSE()
  SET(CORSIX_TH_USE_FFMPEG OFF)
  SET(CORSIX_TH_USE_LIBAV OFF)
  MESSAGE("Note: FFMPEG video is disabled")
ENDIF(WITH_MOVIES)

IF(WITH_FREETYPE2)
  SET(CORSIX_TH_USE_FREETYPE2 ON)
  MESSAGE("Note: FreeType2 is enabled (default)")
ELSE()
  SET(CORSIX_TH_USE_FREETYPE2 OFF)
  MESSAGE("Note: FreeType2 is disabled")
ENDIF(WITH_FREETYPE2)

IF(MSVC)
  IF(WITH_VLD)
    SET(CORSIX_TH_USE_VLD ON)
    MESSAGE("Note: Visual Leak Detector is enabled")
  ELSE()
    SET(CORSIX_TH_USE_VLD OFF)
    MESSAGE("Note: Visual Leak Detector is disabled (default)")
  ENDIF(WITH_VLD)
ELSE()
  SET(CORSIX_TH_USE_VLD OFF)
ENDIF(MSVC)

# Environment handling

CHECK_INCLUDE_FILES(inttypes.h CORSIX_TH_HAS_INTTYPES_H)

# Include individual projects
message("")
# We always build CorsixTH otherwise we would miss the generated header
message("Building CorsixTH")
add_subdirectory(CorsixTH)

IF(BUILD_ANIMVIEWER)
  message("Building AnimView")
  add_subdirectory(AnimView)
ENDIF(BUILD_ANIMVIEWER)

# Documentation generation, construct 'doc' target (or a message it is disabled).

# Try to find 'lua'
IF (WITH_LUAJIT)
    SET (LUA_PROGRAM_NAMES luajit-2.0.3 luajit)
ELSE (WITH_LUAJIT)
    SET (LUA_PROGRAM_NAMES lua53 lua5.3 lua-5.3 lua52 lua5.2 lua-5.2 lua51 lua5.1 lua-5.1 lua)
ENDIF(WITH_LUAJIT)

find_program (LUA_PROGRAM_PATH ${LUA_PROGRAM_NAMES}
  PATHS
    ENV LUA_DIR
    /opt
    /opt/local
    ~
    ~/Library/Frameworks
    /Library/Frameworks
)

IF (LUA_PROGRAM_PATH)
  SET(LUA_PROGRAM_FOUND TRUE)
ELSE (LUA_PROGRAM_PATH)
  SET(LUA_PROGRAM_FOUND FALSE)
ENDIF (LUA_PROGRAM_PATH)

# Find doxygen.
find_package(Doxygen)

# Generate build targets and the doc/index.html file.
IF (DOXYGEN_FOUND OR LUA_PROGRAM_FOUND)
  add_custom_target(doc)

ELSE (DOXYGEN_FOUND OR LUA_PROGRAM_FOUND)
  message("Cannot locate Doxygen or lua, 'doc' target is not available")

ENDIF (DOXYGEN_FOUND OR LUA_PROGRAM_FOUND)


# Add sub-targets of the 'doc' target.
IF (DOXYGEN_FOUND)
  add_custom_target(doc_animview
    ${DOXYGEN_EXECUTABLE} ${CMAKE_CURRENT_SOURCE_DIR}/DoxyGen/animview.doxygen
    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/doc
    COMMENT "Generating API documentation for AnimView" VERBATIM
  )
  add_dependencies(doc doc_animview)


  add_custom_target(doc_leveledit
    ${DOXYGEN_EXECUTABLE} ${CMAKE_CURRENT_SOURCE_DIR}/DoxyGen/leveledit.doxygen
    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/doc
    COMMENT "Generating API documentation for LevelEdit" VERBATIM
  )
  add_dependencies(doc doc_leveledit)


  add_custom_target(doc_corsixth_engine
    ${DOXYGEN_EXECUTABLE} ${CMAKE_CURRENT_SOURCE_DIR}/DoxyGen/corsixth_engine.doxygen
    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/doc
    COMMENT "Generating API documentation for corsixth_engine" VERBATIM
  )
  add_dependencies(doc doc_corsixth_engine)
ENDIF (DOXYGEN_FOUND)

IF (LUA_PROGRAM_FOUND)
  add_custom_target(doc_corsixth_lua
    ${LUA_PROGRAM_PATH} ${CMAKE_CURRENT_SOURCE_DIR}/LDocGen/main.lua
    COMMAND ${CMAKE_COMMAND} -E copy ${CMAKE_CURRENT_SOURCE_DIR}/LDocGen/output/corner_right.gif ${CMAKE_CURRENT_BINARY_DIR}/doc/corsixth_lua
    COMMAND ${CMAKE_COMMAND} -E copy ${CMAKE_CURRENT_SOURCE_DIR}/LDocGen/output/logo.png         ${CMAKE_CURRENT_BINARY_DIR}/doc/corsixth_lua
    COMMAND ${CMAKE_COMMAND} -E copy ${CMAKE_CURRENT_SOURCE_DIR}/LDocGen/output/main.css         ${CMAKE_CURRENT_BINARY_DIR}/doc/corsixth_lua
    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/doc
    COMMENT "Generating API documentation for corsixth_lua" VERBATIM
  )
  add_dependencies(doc doc_corsixth_lua)
ENDIF (LUA_PROGRAM_FOUND)

# Generate doc/index.html file.
IF (DOXYGEN_FOUND OR LUA_PROGRAM_FOUND)
  file(WRITE  ${CMAKE_CURRENT_BINARY_DIR}/doc/index.html "<html>\n")
  file(APPEND ${CMAKE_CURRENT_BINARY_DIR}/doc/index.html "<head><title>CorsixTH source code documentation</title></head>\n")
  file(APPEND ${CMAKE_CURRENT_BINARY_DIR}/doc/index.html "<body>\n")
  file(APPEND ${CMAKE_CURRENT_BINARY_DIR}/doc/index.html "<h1>CorsixTH main program source code documentation</h1>\n")
  file(APPEND ${CMAKE_CURRENT_BINARY_DIR}/doc/index.html "<ul>\n")
ENDIF (DOXYGEN_FOUND OR LUA_PROGRAM_FOUND)

IF (DOXYGEN_FOUND)
  file(APPEND ${CMAKE_CURRENT_BINARY_DIR}/doc/index.html "  <li><a href=\"corsixth_engine/html/index.html\">CorsixTH engine documentation</a>\n")
ENDIF (DOXYGEN_FOUND)

IF (LUA_PROGRAM_FOUND)
  file(APPEND ${CMAKE_CURRENT_BINARY_DIR}/doc/index.html "  <li><a href=\"corsixth_lua/index.html\">CorsixTH Lua documentation</a>\n")
ENDIF (LUA_PROGRAM_FOUND)

IF (DOXYGEN_FOUND)
  file(APPEND ${CMAKE_CURRENT_BINARY_DIR}/doc/index.html "</ul>\n")
  file(APPEND ${CMAKE_CURRENT_BINARY_DIR}/doc/index.html "<h1>CorsixTH helper programs source code documentation</h1>\n")
  file(APPEND ${CMAKE_CURRENT_BINARY_DIR}/doc/index.html "<ul>\n")
  file(APPEND ${CMAKE_CURRENT_BINARY_DIR}/doc/index.html "  <li><a href=\"animview/html/index.html\">Animation viewer documentation</a>\n")
  file(APPEND ${CMAKE_CURRENT_BINARY_DIR}/doc/index.html "  <li><a href=\"leveledit/html/index.html\">Level editor documentation</a>\n")
ENDIF (DOXYGEN_FOUND)

IF (DOXYGEN_FOUND OR LUA_PROGRAM_FOUND)
  file(APPEND ${CMAKE_CURRENT_BINARY_DIR}/doc/index.html "</ul>\n")
  file(APPEND ${CMAKE_CURRENT_BINARY_DIR}/doc/index.html "</body>\n")
  file(APPEND ${CMAKE_CURRENT_BINARY_DIR}/doc/index.html "</html>\n")
ENDIF (DOXYGEN_FOUND OR LUA_PROGRAM_FOUND)

=== CorsixTH/CMakeLists.txt ===
# Sanity check
IF(CORSIX_TH_DONE_TOP_LEVEL_CMAKE)
ELSE(CORSIX_TH_DONE_TOP_LEVEL_CMAKE)
message(FATAL_ERROR "Please run cmake on the top-level directory, not this one.")
ENDIF(CORSIX_TH_DONE_TOP_LEVEL_CMAKE)

# Project Declaration
PROJECT(CorsixTH)

# Basic platform dependent stuff
IF(UNIX)
  IF(APPLE)
    # fruit goes here
    add_subdirectory(SDLMain)
  ELSE(APPLE)
    # regular unix/linux
  ENDIF(APPLE)
ELSE()
  IF(WIN32)
    # Win32 specific
    IF(MSVC)
      # We want to bind against the very latest versions of the MSVC runtimes
      add_definitions(/D "_BIND_TO_CURRENT_VCLIBS_VERSION=1")
    ELSE(MSVC)
      IF(MSYS)
        # MSYS stuff
      ELSE(MSYS)
        # What's left? MINGW? CYGWIN? BORLAND?
      ENDIF(MSYS)
    ENDIF(MSVC)
  ELSE(WIN32)
    # other OS (not UNIX, not 32/64 bit Windows)
  ENDIF(WIN32)
ENDIF(UNIX)

# Modify the config.h based upon our selection of options
CONFIGURE_FILE(${CMAKE_SOURCE_DIR}/CorsixTH/Src/config.h.in ${CMAKE_BINARY_DIR}/CorsixTH/Src/config.h)
INCLUDE_DIRECTORIES(${CMAKE_BINARY_DIR}/CorsixTH/Src/)

# Generate source files list
# Note: Done after generating config.h
FILE(GLOB_RECURSE corsixth_source_files
  ${CMAKE_SOURCE_DIR}/CorsixTH/SrcUnshared/*.cpp
  ${CMAKE_SOURCE_DIR}/CorsixTH/SrcUnshared/*.c
  ${CMAKE_SOURCE_DIR}/CorsixTH/SrcUnshared/*.h
  ${CMAKE_SOURCE_DIR}/CorsixTH/SrcUnshared/*.hpp
  ${CMAKE_SOURCE_DIR}/CorsixTH/Src/*.cpp
  ${CMAKE_SOURCE_DIR}/CorsixTH/Src/*.c
  ${CMAKE_SOURCE_DIR}/CorsixTH/Src/*.hpp
  ${CMAKE_SOURCE_DIR}/CorsixTH/Src/*.h
  ${CMAKE_SOURCE_DIR}/CorsixTH/Src/shaders/*.psh
  ${CMAKE_BINARY_DIR}/CorsixTH/Src/config.h
  ${CMAKE_SOURCE_DIR}/CorsixTH/Lua/api_version.lua
  ${CMAKE_SOURCE_DIR}/CorsixTH/CorsixTH.rc
  ${CMAKE_SOURCE_DIR}/LFS/*.c
  ${CMAKE_SOURCE_DIR}/LPEG/*.c
)

# Declaration of the executable
IF(APPLE)
  add_definitions(-DIS_CORSIXTH_APP)

  set(corsixth_icon_file ${CMAKE_SOURCE_DIR}/CorsixTH/Icon.icns)
  set_source_files_properties(
    ${corsixth_icon_file}
    PROPERTIES
    MACOSX_PACKAGE_LOCATION Resources
  )
  set(MACOSX_BUNDLE_ICON_FILE Icon.icns)

  add_executable(CorsixTH MACOSX_BUNDLE ${corsixth_source_files} ${corsixth_icon_file})

  set_target_properties(CorsixTH PROPERTIES LINK_FLAGS_MINSIZEREL "-dead_strip")
  set_target_properties(CorsixTH PROPERTIES XCODE_ATTRIBUTE_LD_RUNPATH_SEARCH_PATHS "@executable_path/../Frameworks")

  #Add an extra step at the end of the build process to copy the resources into the bundle.
  add_custom_command(TARGET CorsixTH
  					 POST_BUILD
					 COMMAND rsync -rv --include-from ${CMAKE_SOURCE_DIR}/CorsixTH/RequiredResources.txt ${CMAKE_SOURCE_DIR}/CorsixTH/ \${TARGET_BUILD_DIR}/\${FULL_PRODUCT_NAME}/Contents/MacOS
					 COMMAND rsync -rv ${CMAKE_SOURCE_DIR}/CorsixTH/Icon.icns \${TARGET_BUILD_DIR}/\${FULL_PRODUCT_NAME}/Contents/Resources/)

  target_link_libraries(CorsixTH SDL2main)
  INCLUDE_DIRECTORIES(${CMAKE_BINARY_DIR}/CorsixTH/SDLMain/)
ELSE()
  add_executable(CorsixTH ${corsixth_source_files})
ENDIF()

# Finding libraries

# Find SDL
FIND_PACKAGE(SDL2 REQUIRED)
IF(SDL_FOUND)
  INCLUDE_DIRECTORIES(${SDL_INCLUDE_DIR})
  IF(SDLMAIN_LIBRARY STREQUAL "")
    message(FATAL_ERROR "Error: SDL was found but SDLmain was not")
    message("Make sure the path is correctly defined or set the environment variable SDLDIR to the correct location")
  ENDIF(SDLMAIN_LIBRARY STREQUAL "")
  # No need to specify sdlmain separately, the FindSDL.cmake file will take care of that. If not we get an error about it
  TARGET_LINK_LIBRARIES(CorsixTH ${SDL_LIBRARY})
  message("  SDL found")
ELSE(SDL_FOUND)
  message(FATAL_ERROR "Error: SDL library not found, it is required to build. Make sure the path is correctly defined or set the environment variable SDLDIR to the correct location")
ENDIF(SDL_FOUND)

# Find Lua
FIND_PACKAGE(Lua REQUIRED)
IF(Lua_FOUND)
  TARGET_LINK_LIBRARIES(CorsixTH ${LUA_LIBRARY})
  INCLUDE_DIRECTORIES(${LUA_INCLUDE_DIR})
  # Special link flags needed on OSX/64bit, according to: http://luajit.org/install.html
  # If these are not specified, luaL_newstate() returns NULL and we get this:
  #   Fatal error starting CorsixTH: Cannot open Lua state.
  IF(${CMAKE_SYSTEM_NAME} MATCHES "Darwin" AND LUA_INTERPRETER_TYPE STREQUAL "LuaJIT" AND CMAKE_SIZEOF_VOID_P EQUAL 8)
    TARGET_LINK_LIBRARIES(CorsixTH "-pagezero_size 10000" "-image_base 100000000")
  ENDIF()
  message("  ${LUA_INTERPRETER_TYPE} found")
ELSE(Lua_FOUND)
  message(FATAL_ERROR "Error: Lua library not found, it is required to build")
ENDIF(Lua_FOUND)

# Find SDL_mixer
IF(CORSIX_TH_USE_SDL_MIXER)
  FIND_PACKAGE(SDL2_mixer REQUIRED)
  IF(SDLMIXER_FOUND)
    TARGET_LINK_LIBRARIES(CorsixTH ${SDLMIXER_LIBRARY})
    INCLUDE_DIRECTORIES(${SDLMIXER_INCLUDE_DIR})
    message("  SDL_mixer found")
  ELSE(SDLMIXER_FOUND)
    message(FATAL_ERROR "Error: SDL_mixer library not found, even though it was selected to be included")
  ENDIF(SDLMIXER_FOUND)
ENDIF(CORSIX_TH_USE_SDL_MIXER)

message( STATUS "CMAKE_MODULE_PATH=${CMAKE_MODULE_PATH}" )

# Find FFMPEG
IF(CORSIX_TH_USE_FFMPEG)
  FIND_PACKAGE(FFmpeg COMPONENTS AVFORMAT AVCODEC AVUTIL SWSCALE SWRESAMPLE REQUIRED)
  IF(FFMPEG_FOUND)
    TARGET_LINK_LIBRARIES(CorsixTH ${FFMPEG_LIBRARIES})
    INCLUDE_DIRECTORIES(${FFMPEG_INCLUDE_DIRS})
    IF(APPLE)
      TARGET_LINK_LIBRARIES(CorsixTH libz.dylib)
    ENDIF()
    message("  FFmpeg found")
  ELSE(FFMPEG_FOUND)
    message(FATAL_ERROR "Error: FFmpeg library not found, even though it was selected to be included")
  ENDIF(FFMPEG_FOUND)
ENDIF(CORSIX_TH_USE_FFMPEG)

IF(CORSIX_TH_USE_LIBAV)
  FIND_PACKAGE(LibAV COMPONENTS AVFORMAT AVCODEC AVRESAMPLE AVUTIL SWSCALE REQUIRED)
  IF(LIBAV_FOUND)
    TARGET_LINK_LIBRARIES(CorsixTH ${LIBAV_LIBRARIES})
    INCLUDE_DIRECTORIES(${LIBAV_INCLUDE_DIRS})
    IF(APPLE)
      TARGET_LINK_LIBRARIES(CorsixTH libz.dylib)
    ENDIF()
    message("  LibAV found")
  ELSE(LIBAV_FOUND)
    message(FATAL_ERROR "Error: LibAV library not found, even though it was selected to be included")
  ENDIF(LIBAV_FOUND)
ENDIF(CORSIX_TH_USE_LIBAV)

# Find Freetype2
IF(CORSIX_TH_USE_FREETYPE2)
  FIND_PACKAGE(Freetype REQUIRED)
  IF(FREETYPE_FOUND)
    TARGET_LINK_LIBRARIES(CorsixTH ${FREETYPE_LIBRARIES})
    INCLUDE_DIRECTORIES(${FREETYPE_INCLUDE_DIRS})
	IF(APPLE)
	  TARGET_LINK_LIBRARIES(CorsixTH libz.dylib)
      TARGET_LINK_LIBRARIES(CorsixTH libbz2.dylib)
    ENDIF()
    message("  FreeType2 found")
  ELSE(FREETYPE_FOUND)
    message(FATAL_ERROR "Error: FreeType2 library not found, even though it was selected to be used")
  ENDIF(FREETYPE_FOUND)
ENDIF(CORSIX_TH_USE_FREETYPE2)

# Find msinttypes for MSVC
IF(MSVC AND NOT CORSIX_TH_HAS_INTTYPES_H)
  FIND_PATH(MSINTTYPES_INCLUDE_DIRS "inttypes.h" NO_DEFAULT_PATH)
  MESSAGE(STATUS "Adding include directory: ${MSINTTYPES_INCLUDE_DIRS}")
  INCLUDE_DIRECTORIES(${MSINTTYPES_INCLUDE_DIRS})
  SET(CORSIX_TH_HAS_INTTYPES_H 1)
ENDIF(MSVC AND NOT CORSIX_TH_HAS_INTTYPES_H)

IF(MSVC AND CORSIX_TH_USE_VLD)
  FIND_PACKAGE(VLD REQUIRED)
  IF(VLD_FOUND)
    TARGET_LINK_LIBRARIES(CorsixTH ${VLD_LIBRARY})
    INCLUDE_DIRECTORIES(CorsixTH ${VLD_INCLUDE_DIR})
    message("  VLD found")
  ELSE(VLD_FOUND)
    message(FATAL_ERROR "Error: VLD Library not found, it is required to build when USE_VLD is set")
  ENDIF(VLD_FOUND)
ENDIF(MSVC AND CORSIX_TH_USE_VLD)

# Declaration of the install process
IF(APPLE)
  #Just use the prefix as it's sufficient to just set the prefix to /Applications on Mac.
  install(TARGETS CorsixTH BUNDLE DESTINATION .)

  # Fix the OS X bundle to include required libraries (create a redistributable app)
  install(CODE "
    INCLUDE(BundleUtilities)
    SET(BU_CHMOD_BUNDLE_ITEMS ON)
    FIXUP_BUNDLE(${CMAKE_INSTALL_PREFIX}/CorsixTH.app \"\" \"\")
    ")
ELSE()
  install(TARGETS CorsixTH RUNTIME DESTINATION CorsixTH)
  install(DIRECTORY Lua Levels DESTINATION CorsixTH PATTERN "*.svn" EXCLUDE)
  install(DIRECTORY Bitmap DESTINATION CorsixTH
        FILES_MATCHING REGEX ".*\\.(tab|pal|dat|png)$"
        PATTERN "*.svn" EXCLUDE)
  install(FILES CorsixTH.lua ../LICENSE.txt CorsixTH.ico DESTINATION CorsixTH )
ENDIF()

=== debian/changelog ===
corsix-th (0.60-1) unstable; urgency=medium

  [ Alexandre Detiste ]
  * New upstream release.

  [ Phil Morrell ]
  * drop all non-debian patches merged upstream
  * backport include_campaigns.patch pushed upstream
  * backport editor_drag_performance.patch for usability
  * drop obsolete lintian-overrides
  * bump Standards-Version
  * add new project website URL
  * add copyright for new campaign by ChrizmanTV
  * update main copyright authors from LICENSE.txt

 -- Phil Morrell <debian@emorrp1.name>  Wed, 22 Jun 2016 23:05:26 +0100

corsix-th (0.50-2) unstable; urgency=medium

  * backport upstream patch to build with ffmpeg 3.0 (Closes: #821415)
  * use v4 watch file to include pre-releases
  * wrap-and-sort -satb

 -- Phil Morrell <debian@emorrp1.name>  Mon, 18 Apr 2016 19:20:40 +0100

corsix-th (0.50-1) unstable; urgency=medium

  * Initial release. (Closes: #610087)

 -- Alexandre Detiste <alexandre.detiste@gmail.com>  Mon, 29 Feb 2016 15:05:38 +0100

=== debian/control ===
Source: corsix-th
Section: contrib/games
Priority: optional
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders:
 Alexandre Detiste <alexandre.detiste@gmail.com>,
 Phil Morrell <debian@emorrp1.name>,
Build-Depends:
 cmake,
 debhelper (>= 9),
 imagemagick,
 libavdevice-dev (>= 7:2.8),
 libfreetype6-dev,
 liblua5.2-dev,
 libsdl2-dev,
 libsdl2-mixer-dev,
 lua5.2,
Standards-Version: 3.9.8
Homepage: http://corsixth.com
Vcs-Git: https://anonscm.debian.org/git/pkg-games/corsix-th.git
Vcs-Browser: https://anonscm.debian.org/cgit/pkg-games/corsix-th.git

Package: corsix-th
Architecture: any
Depends:
 corsix-th-data (= ${source:Version}),
 lua-filesystem,
 lua-lpeg,
 ${misc:Depends},
 ${shlibs:Depends},
Recommends:
 theme-hospital-data | theme-hospital-demo-data | game-data-packager,
Description: Open source clone of Theme Hospital
 Theme Hospital was a simulation computer game developed by Bullfrog
 Productions and published by Electronic Arts in 1997, in which the player
 designs and operates a hospital.
 .
 The game currently requires the original graphics and tries to mimic the
 original as closely as possible. Therefore you will need a copy of the
 original game for this package to be useful.

Package: corsix-th-data
Architecture: all
Depends:
 ${misc:Depends},
Description: Open source clone of Theme Hospital (data package)
 Theme Hospital was a simulation computer game developed by Bullfrog
 Productions and published by Electronic Arts in 1997, in which the player
 designs and operates a hospital.
 .
 The game currently requires the original graphics and tries to mimic the
 original as closely as possible. Therefore you will need a copy of the
 original game for this package to be useful.
 .
 (This package contains the data files)

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ --parallel --buildsystem=cmake

override_dh_auto_install:
	dh_auto_install
	rm debian/tmp/usr/CorsixTH/CorsixTH.ico
	rm debian/tmp/usr/CorsixTH/LICENSE.txt

	mkdir -p debian/corsix-th/usr/lib/games/corsix-th/
	mv debian/tmp/usr/CorsixTH/CorsixTH debian/corsix-th/usr/lib/games/corsix-th/

	for size in $$(identify ico:CorsixTH/CorsixTH.ico | awk '{print $$3}'); \
	do \
		mkdir -p debian/corsix-th/usr/share/icons/hicolor/$$size/apps/ ; \
		convert ico:`identify ico:CorsixTH/CorsixTH.ico | sed -n "/ $$size /s/^.*=>\(CorsixTH\/CorsixTH.ico\[[0-9]\+]\) .*/\1/gp"` \
			-verbose debian/corsix-th/usr/share/icons/hicolor/$$size/apps/corsix-th.png ; \
	done

	mkdir -p debian/corsix-th/usr/share/icons/hicolor/scalable/apps/
	install -m0644 CorsixTH/Original_Logo.svg debian/corsix-th/usr/share/icons/hicolor/scalable/apps/corsix-th.svg

	mkdir -p debian/corsix-th-data/usr/share/games/corsix-th/
	mv debian/tmp/usr/CorsixTH/* debian/corsix-th-data/usr/share/games/corsix-th/

override_dh_installchangelogs:
	dh_installchangelogs CorsixTH/changelog.txt

=== debian/watch ===
version=4
opts="uversionmangle=s/-/~/" \
 https://github.com/CorsixTH/CorsixTH/tags \
 (?:.*/)?v(\d[\-+\.:\~\da-zA-Z]*)@ARCHIVE_EXT@

## corsix-th 0.61

=== CMakeLists.txt ===
--- 
+++ 
@@ -11,9 +11,21 @@
 #   - WITH_LIBAV   : Whether to use LibAV (as opposed to FFMEPG) when building movies
 #   - WITH_VLD     : Build with Visual Leak Detector (requires Visual Studio)
 
+CMAKE_MINIMUM_REQUIRED(VERSION 3.2)
+
+SET(CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/CMake)
+
+IF(CMAKE_GENERATOR MATCHES "^Visual Studio 14 2015" OR CMAKE_GENERATOR MATCHES "^Visual Studio 15 2017")
+  OPTION(USE_VCPKG_DEPS "Build vcpkg dependencies locally" OFF)
+ENDIF()
+
+if(USE_VCPKG_DEPS)
+  message("Note: Using locally built vcpkg dependencies.")
+  include(VcpkgDeps)
+endif()
+
 PROJECT(CorsixTH_Top_Level)
-CMAKE_MINIMUM_REQUIRED(VERSION 2.6)
-SET(CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/CMake)
+
 INCLUDE(CheckCXXCompilerFlag)
 CHECK_CXX_COMPILER_FLAG("-std=c++11" COMPILER_SUPPORTS_CXX11)
 CHECK_CXX_COMPILER_FLAG("-std=c++0x" COMPILER_SUPPORTS_CXX0X)
@@ -27,6 +39,12 @@
 ENDIF(MINGW)
 INCLUDE(CheckIncludeFiles)
 SET(CORSIX_TH_DONE_TOP_LEVEL_CMAKE ON)
+
+
+# Dependency management
+if ( UNIX AND CMAKE_COMPILER_IS_GNU)
+  OPTION(USE_PRECOMPILED_DEPS "Use Precompiled Dependencies" OFF) # Make *nix systems opt in
+endif()
 
 # Define our options
 OPTION(WITH_SDL "Activate SDL Renderer" ON) # our default option
@@ -90,8 +108,13 @@
   SET(CORSIX_TH_USE_VLD OFF)
 ENDIF(MSVC)
 
+# Get precompiled dependencies before running the various find modules
+if ( USE_PRECOMPILED_DEPS )
+  message("Note: Using precompiled dependencies.")
+  include( PrecompiledDeps )
+endif()
+
 # Environment handling
-
 CHECK_INCLUDE_FILES(inttypes.h CORSIX_TH_HAS_INTTYPES_H)
 
 # Include individual projects

=== AnimView/CMakeLists.txt ===
# Project Declaration
PROJECT(AnimView)

# Generate source files list
# Note: do not use generic includes (*.cpp and such) this will break things with cmake
SET(animview_source_files
  app.cpp
  frmMain.cpp
  frmSprites.cpp
  rnc.cpp
  th.cpp
  tinystr.cpp
  tinyxml.cpp
  tinyxmlerror.cpp
  tinyxmlparser.cpp
  app.h
  backdrop.h
  frmMain.h
  frmSprites.h
  th.h
  tinystr.h
  tinyxml.h
  AnimView.rc
)

# Declaration of the executable
IF(APPLE)

  set(corsixth_icon_file ${CMAKE_SOURCE_DIR}/AnimView/Icon.icns)
  set_source_files_properties(
    ${corsixth_icon_file}
    PROPERTIES
    MACOSX_PACKAGE_LOCATION Resources
  )
  set(MACOSX_BUNDLE_ICON_FILE Icon.icns)

  add_executable( 
    AnimView
    MACOSX_BUNDLE
    ${animview_source_files}
    ${corsixth_icon_file}
  )

  set_target_properties(AnimView PROPERTIES LINK_FLAGS_MINSIZEREL "-dead_strip")
  set_target_properties(AnimView PROPERTIES XCODE_ATTRIBUTE_LD_RUNPATH_SEARCH_PATHS "@executable_path/../Frameworks")
  
ELSE()
  add_executable( 
    AnimView 
    WIN32 # This prevents the dos console showing up
    ${animview_source_files}
  )
ENDIF()

# Finding libraries

# Find WxWidgets
SET(wxWidgets_USE_LIBS core base) # optionally: more than wx std libs
FIND_PACKAGE(wxWidgets REQUIRED)
IF(wxWidgets_FOUND)
  LINK_LIBRARIES(${wxWidgets_LIBRARIES})
  INCLUDE_DIRECTORIES(${wxWidgets_INCLUDE_DIRS})
  INCLUDE(${wxWidgets_USE_FILE})
  TARGET_LINK_LIBRARIES(AnimView ${wxWidgets_LIBRARIES})
  message("  wxWidgets found")
ELSE(wxWidgets_FOUND)
  message(FATAL_ERROR "error: wxWdigets library not found, it is required to build")
  message("Make sure the path is correctly defined or set the environment variable WXWIN to the correct location")
ENDIF(wxWidgets_FOUND)

# Basic platform dependant stuff
IF(UNIX)
  IF(APPLE)
    # fruit goes here
  ELSE(APPLE)
    # regular unix/linux
  ENDIF(APPLE)
ELSE(UNIX)
  IF(WIN32)
    # Win32 specific
    IF(MSVC)
      # We want to bind against the very latest versions of the MSVC runtimes
      add_definitions(/D "_BIND_TO_CURRENT_VCLIBS_VERSION=1")
    ELSE(MSVC)
      IF(MSYS)
        # MSYS stuff
      ELSE(MSYS)
        # What's left? MINGW? CYGWIN? BORLAND?
      ENDIF(MSYS)
    ENDIF(MSVC)
  ELSE(WIN32)
    # other OS (not UNIX, not 32/64 bit Windows)
  ENDIF(WIN32)
ENDIF(UNIX)

IF(APPLE)
  install(TARGETS AnimView BUNDLE DESTINATION .)
  
  # Fix the OS X bundle to include required libraries (create a redistributable app)
  install(CODE "
    INCLUDE(BundleUtilities)
    SET(BU_CHMOD_BUNDLE_ITEMS ON)
    FIXUP_BUNDLE(${CMAKE_INSTALL_PREFIX}/AnimView.app \"\" \"\")
    ")
ELSE()
  install(TARGETS AnimView RUNTIME DESTINATION AnimView)
  install(FILES LICENSE.txt DESTINATION AnimView )
ENDIF()

=== CorsixTH/CMakeLists.txt ===
--- 
+++ 
@@ -85,23 +85,33 @@
   add_executable(CorsixTH ${corsixth_source_files})
 ENDIF()
 
+# Add an extra step to copy built DLLs on MSVC
+IF(USE_VCPKG_DEPS)
+  INCLUDE(CopyVcpkgLua)
+ENDIF()
+
 # Finding libraries
 
 # Find SDL
-FIND_PACKAGE(SDL2 REQUIRED)
-IF(SDL_FOUND)
-  INCLUDE_DIRECTORIES(${SDL_INCLUDE_DIR})
-  IF(SDLMAIN_LIBRARY STREQUAL "")
-    message(FATAL_ERROR "Error: SDL was found but SDLmain was not")
-    message("Make sure the path is correctly defined or set the environment variable SDLDIR to the correct location")
-  ENDIF(SDLMAIN_LIBRARY STREQUAL "")
-  # No need to specify sdlmain separately, the FindSDL.cmake file will take care of that. If not we get an error about it
-  TARGET_LINK_LIBRARIES(CorsixTH ${SDL_LIBRARY})
-  message("  SDL found")
-ELSE(SDL_FOUND)
-  message(FATAL_ERROR "Error: SDL library not found, it is required to build. Make sure the path is correctly defined or set the environment variable SDLDIR to the correct location")
-ENDIF(SDL_FOUND)
-
+IF (MSVC AND USE_VCPKG_DEPS)
+  FIND_PACKAGE(SDL2 CONFIG REQUIRED)
+  TARGET_LINK_LIBRARIES(CorsixTH SDL2::SDL2)
+  TARGET_LINK_LIBRARIES(CorsixTH SDL2::SDL2main)
+ELSE()
+  FIND_PACKAGE(SDL2 REQUIRED)
+  IF(SDL_FOUND)
+    INCLUDE_DIRECTORIES(${SDL_INCLUDE_DIR})
+    IF(SDLMAIN_LIBRARY STREQUAL "")
+      message(FATAL_ERROR "Error: SDL was found but SDLmain was not")
+      message("Make sure the path is correctly defined or set the environment variable SDLDIR to the correct location")
+    ENDIF(SDLMAIN_LIBRARY STREQUAL "")
+    # No need to specify sdlmain separately, the FindSDL.cmake file will take care of that. If not we get an error about it
+    TARGET_LINK_LIBRARIES(CorsixTH ${SDL_LIBRARY})
+    message("  SDL found")
+  ELSE(SDL_FOUND)
+    message(FATAL_ERROR "Error: SDL library not found, it is required to build. Make sure the path is correctly defined or set the environment variable SDLDIR to the correct location")
+  ENDIF(SDL_FOUND)
+ENDIF()
 # Find Lua
 FIND_PACKAGE(Lua REQUIRED)
 IF(Lua_FOUND)
@@ -118,6 +128,10 @@
   message(FATAL_ERROR "Error: Lua library not found, it is required to build")
 ENDIF(Lua_FOUND)
 
+# Add threading library
+find_package(Threads)
+target_link_libraries(CorsixTH ${CMAKE_THREAD_LIBS_INIT})
+
 # Find SDL_mixer
 IF(CORSIX_TH_USE_SDL_MIXER)
   FIND_PACKAGE(SDL2_mixer REQUIRED)
@@ -209,7 +223,7 @@
     ")
 ELSE()
   install(TARGETS CorsixTH RUNTIME DESTINATION CorsixTH)
-  install(DIRECTORY Lua Levels DESTINATION CorsixTH PATTERN "*.svn" EXCLUDE)
+  install(DIRECTORY Campaigns Lua Levels DESTINATION CorsixTH PATTERN "*.svn" EXCLUDE)
   install(DIRECTORY Bitmap DESTINATION CorsixTH
         FILES_MATCHING REGEX ".*\\.(tab|pal|dat|png)$"
         PATTERN "*.svn" EXCLUDE)

=== CorsixTH/SDLMain/CMakeLists.txt ===
IF(APPLE)
	find_package(SDL2 REQUIRED)

	set(CMAKE_OSX_ARCHITECTURES "x86_64")	
	include_directories(${SDL_INCLUDE_DIR})

	add_library (SDL2main STATIC SDLMain.m)
endif(APPLE)

=== debian/changelog ===
corsix-th (0.61-1) unstable; urgency=medium

  [ Alexandre Detiste ]
  * New upstream version 0.61

  [ Phil Morrell ]
  * add pedantic lintian overrides
  * use https copyright-format url for policy v4.0.0
  * bump Standards-Version, no changes needed
  * add upstream signature to verify releases
  * drop patches released upstream
  * update main copyright authors from LICENSE.txt
  * Change Vcs-* to point to salsa.debian.org

 -- Phil Morrell <debian@emorrp1.name>  Thu, 11 Jan 2018 22:42:02 +0000

corsix-th (0.60-2) unstable; urgency=medium

  * remove obsolete rnc.pp copyright comment.
    Thanks to Alexandre Detiste
  * enable unit tests with newly packaged lua-busted
  * more flexible tag matching in debian/watch
  * bump debhelper compat to 10

 -- Phil Morrell <debian@emorrp1.name>  Tue, 15 Nov 2016 18:08:55 +0000

=== debian/control ===
--- 
+++ 
@@ -7,18 +7,19 @@
  Phil Morrell <debian@emorrp1.name>,
 Build-Depends:
  cmake,
- debhelper (>= 9),
+ debhelper (>= 10),
  imagemagick,
  libavdevice-dev (>= 7:2.8),
  libfreetype6-dev,
  liblua5.2-dev,
  libsdl2-dev,
  libsdl2-mixer-dev,
+ lua-busted,
  lua5.2,
-Standards-Version: 3.9.8
+Standards-Version: 4.1.1
 Homepage: http://corsixth.com
-Vcs-Git: https://anonscm.debian.org/git/pkg-games/corsix-th.git
-Vcs-Browser: https://anonscm.debian.org/cgit/pkg-games/corsix-th.git
+Vcs-Git: https://salsa.debian.org/games-team/corsix-th.git
+Vcs-Browser: https://salsa.debian.org/games-team/corsix-th
 
 Package: corsix-th
 Architecture: any

=== debian/rules ===
--- 
+++ 
@@ -3,7 +3,7 @@
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
 
 %:
-	dh $@ --parallel --buildsystem=cmake
+	dh $@
 
 override_dh_auto_install:
 	dh_auto_install
@@ -26,5 +26,9 @@
 	mkdir -p debian/corsix-th-data/usr/share/games/corsix-th/
 	mv debian/tmp/usr/CorsixTH/* debian/corsix-th-data/usr/share/games/corsix-th/
 
+override_dh_auto_test:
+	dh_auto_test
+	busted -C CorsixTH/Luatest --verbose
+
 override_dh_installchangelogs:
 	dh_installchangelogs CorsixTH/changelog.txt

=== debian/watch ===
version=4
opts=uversionmangle=s/-/~/,\
pgpsigurlmangle=s`archive/v@ANY_VERSION@(@ARCHIVE_EXT@)`releases/download/v$1/CorsixTH-$1$2\.asc` \
 https://github.com/CorsixTH/CorsixTH/tags \
 (?:.*/)?v?@ANY_VERSION@@ARCHIVE_EXT@
